Subject: bug#62279: closed (Re: bug#62279: Add an option to restore C-h b "Prefix Command" output)

From: [email-masked] (GNU bug Tracking System)
Date: Thu, 23 Mar 2023 08:34:02 +0000

Your bug report

#62279: Add an option to restore C-h b "Prefix Command" output

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
62279: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=62279
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#62279: Add an option to restore C-h b "Prefix Command" output
From: Eli Zaretskii <[email-masked]>
To: Bob Rogers <[email-masked]>
Cc: [email-masked]
Date: Thu, 23 Mar 2023 10:33:53 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

> From: Bob Rogers <[email-masked]>
> Date: Sun, 19 Mar 2023 12:59:45 -0700
> CC: [email-masked]
> 
>    From: Eli Zaretskii <[email-masked]>
>    Date: Sun, 19 Mar 2023 21:35:37 +0200
> 
>    > From: Bob Rogers <[email-masked]>
>    > Date: Sun, 19 Mar 2023 12:26:46 -0700
>    > 
>    >    Pursuant to the 'No more "Prefix Command" in C-h m' discussion in the
>    > emacs-devel list.
> 
>    Thanks.
> 
>    > --- a/etc/NEWS
>    > +++ b/etc/NEWS
>    > @@ -61,6 +61,11 @@ This allows the user to customize the prompt that is appended by
>    >  This is used for displaying the time and date components of
>    >  'display-time-mode'.
>    >  
>    > +** New user option 'describe-bindings-show-prefixes'.
>    > +If true (the default is false), restores the "Prefix Command" entries
> 
>    We use "If non-nil", not "If true".  And similarly for "false".
> 
> Guess I've been thinking too much in Perl lately.  ;-}
> 
>    > +in 'describe-binding' ('C-h b') output for keys that are prefixes, the
>    > +details of which are shown later (regardless of this option setting).
> 
>    This NEWS entry should go to where the change in "C-h b"s behavior is
>    described in NEWS (on emacs-29 branch), and should be reworded to tell
>    users how to get the previous behavior back ("To get the previous
>    behavior back, customize ...").
> 
> OK.  I also subordinated it to the "Keymap descriptions have changed"
> entry, since that seemed apt.
> 
>    > +(defcustom describe-bindings-show-prefixes nil
>    > +  "Non-nil shows prefixes in the output buffer of `describe-bindings'."
>    > +  :type 'boolean
>    > +  :group 'help
>    > +  :version "30.1")
> 
>    This should be "29.1".  Since the behavior change was introduced in
>    Emacs 29, we need to add this option in the same version.
> 
> OK, I wasn't sure Lars' change actually made it into 29.

Thanks, I've now installed this (with some minor changes) on the
emacs-29 branch, and I'm therefore closing this bug.

Subject: Add an option to restore C-h b "Prefix Command" output
From: Bob Rogers <[email-masked]>
To: [email-masked]
Date: Sun, 19 Mar 2023 12:26:46 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

Tags: patch

   Pursuant to the 'No more "Prefix Command" in C-h m' discussion in the
emacs-devel list.

					-- Bob Rogers
					   http://www.rgrjr.com/

In GNU Emacs 30.0.50 (build 1, x86_64-pc-linux-gnu, GTK+ Version
 3.24.34, cairo version 1.16.0) of 2023-03-13 built on orion
Repository revision: a79d209748857c7d63ac48a7172a89e5ad1e752b
Repository branch: rgr-smtpmail-env-from
Windowing system distributor 'The X.Org Foundation', version 11.0.12003000
System Description: openSUSE Leap 15.4

Configured using:
 'configure --with-dbus=no --with-gsettings=no --with-gif=ifavailable
 --with-tiff=no --with-gnutls=yes --with-gconf=no'

Add an option to restore C-h b "Prefix Command" output

* lisp/help.el (describe-bindings-show-prefixes):  Option to enable prefixes.
(describe-map):  If true, restore "Prefix Command" output.
* etc/NEWS:  Describe the new option.

diff --git a/etc/NEWS b/etc/NEWS
index 3b02e85b691..5a4a038e953 100644
--- a/etc/NEWS
+++ b/etc/NEWS
@@ -61,6 +61,11 @@ This allows the user to customize the prompt that is appended by
 This is used for displaying the time and date components of
 'display-time-mode'.
 
+** New user option 'describe-bindings-show-prefixes'.
+If true (the default is false), restores the "Prefix Command" entries
+in 'describe-binding' ('C-h b') output for keys that are prefixes, the
+details of which are shown later (regardless of this option setting).
+
 
 * Editing Changes in Emacs 30.1
 
diff --git a/lisp/help.el b/lisp/help.el
index 83be85b1ee4..37a08718f9d 100644
--- a/lisp/help.el
+++ b/lisp/help.el
@@ -717,6 +717,12 @@ describe-bindings-outline
   :group 'help
   :version "29.1")
 
+(defcustom describe-bindings-show-prefixes nil
+  "Non-nil shows prefixes in the output buffer of `describe-bindings'."
+  :type 'boolean
+  :group 'help
+  :version "30.1")
+
 (declare-function outline-hide-subtree "outline")
 
 (defun describe-bindings (&optional prefix buffer)
@@ -1699,6 +1705,7 @@ describe-map
               (setq vect (cdr vect))
               (setq end (caar vect))))
           (when (or (not (eq start end))
+                    describe-bindings-show-prefixes
                     ;; Don't output keymap prefixes.
                     (not (keymapp definition)))
             (when first